## limesuite 23.10.0

=== debian/changelog ===
limesuite (23.10.0) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom latest feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 02 Nov 2023 12:36:49 +0000

limesuite (23.10.0-1) unstable; urgency=low

  * Release 23.10.0 (2023-10-23)

 -- Lime Microsystems <apps@limemicro.com>  Sat, 15 Oct 2022 16:30:00 +0100
