=== debian/changelog ===
limesuite (23.11.0) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom latest feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 20 Nov 2023 20:54:55 +0000

limesuite (23.11.0-1) unstable; urgency=low

  * Release 23.11.0 (2023-11-19)

 -- Lime Microsystems <apps@limemicro.com>  Sat, 15 Oct 2022 16:30:00 +0100
