=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Vcs-Git: https://github.com/myriadrf/LimeSuite.git
 Vcs-Browser: https://github.com/myriadrf/LimeSuite.git
 
-Package: liblimesuite23.10-1
+Package: liblimesuite23.11-1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -30,7 +30,7 @@
 Section: libdevel
 Architecture: any
 Depends:
-    liblimesuite23.10-1 (= ${binary:Version}),
+    liblimesuite23.11-1 (= ${binary:Version}),
     ${misc:Depends}
 Description: Lime Suite - development files
  Lime Suite application software.
@@ -39,7 +39,7 @@
 Section: comm
 Architecture: any
 Depends:
-    liblimesuite23.10-1 (= ${binary:Version}),
+    liblimesuite23.11-1 (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends},
     xdg-utils
@@ -59,7 +59,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
-    liblimesuite23.10-1 (= ${binary:Version}),
+    liblimesuite23.11-1 (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
 Description: Lime Suite - SoapySDR bindings
@@ -73,7 +73,7 @@
 Description: Lime Suite - USB rules for udev
  Lime Suite application software.
 
-Package: limesuite-images23.10
+Package: limesuite-images23.11
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -87,7 +87,7 @@
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images23.10
+Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images23.11
 Description: Lime Suite - Install firmware and gateware images
  Lime Suite application software.
  .
