=== debian/changelog ===
limesuite (23.11.0+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with gcc-15. (Closes: #1097297)
  * Fix FTBFS with cmake-4. (Closes: #1113231)

 -- Christoph Berg <myon@debian.org>  Wed, 10 Sep 2025 16:59:04 +0000

limesuite (23.11.0+dfsg-3) unstable; urgency=medium

  * Team upload.

  * Replaced obsolete build dependency pkg-config with pkgconf.
  * Added Appstream metainfo announcing hardware support.
  * Trimmed path globs in d/copyright.  Thanks Lintian.
  * Updated Standards-Version from 4.6.0 to 4.7.0.
  * Added d/gbp.conf to enforce use of pristine-tar.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 27 Apr 2024 11:31:55 +0200

limesuite (23.11.0+dfsg-2) unstable; urgency=medium

  * Source-only upload.

 -- Christoph Berg <myon@debian.org>  Sat, 25 Nov 2023 11:19:23 +0000

limesuite (23.11.0+dfsg-1) unstable; urgency=medium

  * New upstream version 23.11.0+dfsg.
  * Move 64-limesuite.rules to /usr/lib/udev/rules.d/.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Nov 2023 15:30:42 +0000

limesuite (22.09.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with GCC-13 (Closes: #1037754)

 -- tony mancill <tmancill@debian.org>  Sat, 15 Jul 2023 13:08:16 -0700
