=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%limesuite-$1.tar.gz%, \
      dversionmangle=s/\+dfsg$//, repacksuffix=+dfsg" \
https://github.com/myriadrf/LimeSuite/tags .*/v([\d\.]+)\.tar\.gz
