## limesuite 23.11.0.1.2141.9dce.202408012026

=== debian/changelog ===
limesuite (23.11.0.1.2141.9dce.202408012026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 01 Aug 2024 20:27:38 +0000
