## limesuite 23.11.0.1.2141.9dce.202408022026

=== debian/changelog ===
limesuite (23.11.0.1.2141.9dce.202408022026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Fri, 02 Aug 2024 20:27:41 +0000
