## limesuite 23.11.0.1.2141.9dce.202408032026

=== debian/changelog ===
limesuite (23.11.0.1.2141.9dce.202408032026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sat, 03 Aug 2024 20:27:42 +0000
